function love.load()
	--sets up window variables
	window = { translate = {x = 0, y = 0}, zoom = 1 }
	--rectnagle variable
	rect = {x = 100, y = 100, width = 200, height = 100}
end

function love.draw()
	--debugs mouse coordinates
	love.graphics.setColor(255,255,255)
	local x,y = love.mouse.getPosition()
	love.graphics.print(x ..', '.. y, 1, 1) 
	love.graphics.print(x/window.zoom+window.translate.x ..', '.. y/window.zoom+window.translate.y, 1, 15) 

	-- draws xy axies
	love.graphics.setColor(0,255,0)
	love.graphics.line(0,0 - window.translate.y*window.zoom,800,0 - window.translate.y*window.zoom)
	love.graphics.line(0 - window.translate.x*window.zoom,0,0 - window.translate.x*window.zoom,600)

	--translate and scale
	love.graphics.translate(window.translate.x, window.translate.y)
	love.graphics.scale(window.zoom)

	--draws the circle in the middle of the screen
	love.graphics.setColor(255,255,255)
	love.graphics.circle('fill',800/2, 600/2,5,32)

	--draws the recntagle
	love.graphics.rectangle('fill', rect.x, rect.y, rect.width, rect.height)

	--draws red point in the middle of the rectangle
	love.graphics.setColor(255,0,0)
	love.graphics.point(rect.x+rect.width/2, rect.y+rect.height/2)
end

function love.mousepressed(x, y, k)
	if k == 'wu' then
		-- zoom in to point
		local mouse_x = x - window.translate.x
		local mouse_y = y - window.translate.y
		local lastzoom = window.zoom

		window.zoom = window.zoom + 0.1

		local newx = mouse_x * (window.zoom/lastzoom)
		local newy = mouse_y * (window.zoom/lastzoom)

		window.translate.x = window.translate.x + (mouse_x-newx)
		window.translate.y = window.translate.y + (mouse_y-newy)
	elseif k == 'wd' then
		--zoom out of point
		local mouse_x = x - window.translate.x
		local mouse_y = y - window.translate.y
		local lastzoom = window.zoom

		window.zoom = window.zoom - 0.1

		local newx = mouse_x * (window.zoom/lastzoom)
		local newy = mouse_y * (window.zoom/lastzoom)

		window.translate.x = window.translate.x + (mouse_x-newx)
		window.translate.y = window.translate.y + (mouse_y-newy)
	elseif k == 'm' then
		--resets screen
		window.zoom = 1
		window.translate.x = 0
		window.translate.y = 0
	elseif k == 'l' then
		--zoom to center
		window.zoom = window.zoom +.1
		local ox = love.graphics.getWidth() 
		local oy = love.graphics.getHeight() 
		local tx = ox * window.zoom
		local ty = oy * window.zoom
		local vx = ox - tx
		local vy = oy - ty
		window.translate.x = vx/2
		window.translate.y = vy/2
	elseif k == 'r' then
		--zoom out of center
		window.zoom = window.zoom -.1
		local ox = love.graphics.getWidth() 
		local oy = love.graphics.getHeight() 
		local tx = ox * window.zoom
		local ty = oy * window.zoom
		local vx = ox - tx
		local vy = oy - ty
		window.translate.x = vx/2
		window.translate.y = vy/2
	end
end